【C++算法】6.双指针_有效三角形的个数

文章目录


题目链接:

611.有效三角形的个数


题目描述:


解法

数学知识:

给我们3个数,判断是否能够构成三角形。

平时:a+b>c,a+c>b,b+c>a(判断三次)

如果已知3个数的大小 ,我们可以只判断较小的两个数之和是否大于第三个数。(判断一次)

我们可以先对整个数组排序。
解法一(暴力求解)

三层 for 循环枚举出所有的三元组,并且判断是否能构成三角形。

如果能构成三角形,需要满足任意两边之和要大于第三边。但是实际上只需让较小的两条边之和大于第三边即可。

经过我们的优化后,暴力枚举法的时间复杂度从3n3变成了nlogn+n3。
解法二(排序 + 双指针)

排完序后,数组就有序了。我们就可以利用单调性使用双指针算法来解决问题。

比如如果a,b,c取如图的位置。a+b>c,那么left往后移动,得到的结果都可以组成三角形。

如果a,b,c取如图的位置。a+b<=c,那么无论left往后移动多少,得到的结果都不可以组成三角形。

步骤:

  1. 先固定最大的数(固定n次)
  2. 在最大的数的左区间内,使用双指针算法 ,快速统计出符合要求的三元组的个数。
  3. 然后更换固定的最大的数 ,依次类推。

C++ 算法代码:

解法一(暴力求解)(会超时)O(nlogn+n3)

cpp 复制代码
class Solution {
public:
    int triangleNumber(vector<int>& nums) {
        // 1. 排序
        sort(nums.begin(), nums.end());
        int n = nums.size(), ret = 0;
        // 2. 从小到大枚举所有的三元组
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                for (int k = j + 1; k < n; k++) {
                    // 当最小的两个边之和大于第三边的时候,统计答案
                    if (nums[i] + nums[j] > nums[k])
                        ret++;
                } 
            }
        }
        return ret;
    }
};

解法二(排序 + 双指针)O(n2)

cpp 复制代码
class Solution 
{
public:
    int triangleNumber(vector<int>& nums) 
    {
        // 1. 优化,排序一下数组
        sort(nums.begin(), nums.end());
        // 2. 利用双指针解决问题
        int ret = 0, n = nums.size();
        for(int i = n - 1; i >= 2; i--) // 先固定最大的数,从后往前固定
        {
            // 利用双指针快速统计符合要求的三元组的个数
            int left = 0, right = i - 1;
            while(left < right)
            {
                if(nums[left] + nums[right] > nums[i]){
                    ret += right - left;
                    right--;
                }
                else{
                    left++;
                }
            }
        }
        return ret;
    }
};

图解:

nums=[2,2,3,4]

  1. 优化,排序一下数组,原数组已经顺序了,所以没有变化。

  2. 进入第一层循环,i=3,left=0,right=2

    nums[0] + nums[2] > nums[3]

    ret=ret + right - left=2

    right--,right=1

  3. i=3,left=0,right=1

    nums[0] + nums[1] = nums[3]

    left++,left=1

    跳出while循环,i--

  4. i=2,left=0,right=1

    nums[0] + nums[1] > nums[2]

    ret=ret + right - left=3

    right--,right=0

    跳出while循环,i--

  5. i=1跳出外层for循环

  6. ret=3

相关推荐
Nontee3 分钟前
Quartz 新手入门:定时任务的两个承诺
开发语言·windows·python
?abc!25 分钟前
(数组)448. 找到所有数组中消失的数字
算法
\光辉岁月/26 分钟前
2.异常类
java·开发语言·异常类
淡海水27 分钟前
05-03-源码-Boehm GC分配与碎片管理
开发语言·算法·unity·c#·游戏引擎·gc
努力实干29 分钟前
C++ 面向对象与工程架构
开发语言·c++·架构
代钦塔拉35 分钟前
【C++/Qt 进阶】设计模式系列(6):桥接模式——把“两个独立变化的维度“拆开
c++·qt·设计模式
十年Java程序媛35 分钟前
JVM 基础与 GC 垃圾回收详解|可达性分析、分代模型、垃圾收集器、STW
java·开发语言·jvm·spring boot·后端·面试
估值探索者37 分钟前
【Python量化选股流水线 #03】候选股怎么排序?动量+低波+流动性三因子打分取 Top-N
开发语言·python·接口·api接口·股票数据接口·数据接口·股票数据api接口
骑士雄师37 分钟前
supervisor 中关于上下文多轮信息维护常用到的python语法
开发语言·python
青少儿编程课堂1 小时前
蓝桥杯·全国青少年信息素养大赛·电子学会Python/C/C++考级:任意进制互转与大数多进制加法解析
c++·python·算法·bfs·信息学竞赛